function go() {
	
	// Receive inout from textarea box
	all_text = document.getElementById("text_input").value;
	
	// Parse input. Split by space and linebreaks converted to space
	all_text = all_text.replace( /\n/g, " " ).split( " " );
	
	// ###############################################################################
	
	// Iterate and identify through textarea values
	for (var i = 0; i < all_text.length; i++) {
		
		// Design Variables Input
		if (all_text[i]=="Powering"){powering_ = calc_steps(all_text[i+1],all_text[i+2],all_text[i+3])};
		if (all_text[i]=="Ice_Class"){ice_class_ = calc_steps(all_text[i+1],all_text[i+2],all_text[i+3])};
		if (all_text[i]=="Speed"){speed_ = calc_steps(all_text[i+1],all_text[i+2],all_text[i+3])};
		if (all_text[i]=="Accommodation"){accommodation_ = calc_steps(all_text[i+1],all_text[i+2],all_text[i+3])};
		if (all_text[i]=="Crane"){crane_ = calc_steps(all_text[i+1],all_text[i+2],all_text[i+3])};
		if (all_text[i]=="DP"){dp_ = calc_steps(all_text[i+1],all_text[i+2],all_text[i+3])};
		if (all_text[i]=="ROV_Number"){rov_number_ = calc_steps(all_text[i+1],all_text[i+2],all_text[i+3])};
		if (all_text[i]=="Deck_Area"){deck_area_ = calc_steps(all_text[i+1],all_text[i+2],all_text[i+3])};
		
		// Context Variables Input
		if (all_text[i]=="Oil_Price"){fuel__ = calc_steps(all_text[i+1],all_text[i+2],all_text[i+3])};
		if (all_text[i]=="Offshore_Distance"){offshore_distance__ = calc_steps(all_text[i+1],all_text[i+2],all_text[i+3])};
		if (all_text[i]=="Duration"){duration__ = calc_steps(all_text[i+1],all_text[i+2],all_text[i+3])};
		if (all_text[i]=="Depth"){depth__ = calc_steps(all_text[i+1],all_text[i+2],all_text[i+3])};
		if (all_text[i]=="Weather"){weather__ = calc_steps(all_text[i+1],all_text[i+2],all_text[i+3])};
		if (all_text[i]=="Location"){location__ = calc_steps(all_text[i+1],all_text[i+2],all_text[i+3])};
		
		// Design Attributes - Calculating Utility (applied under attribute calculations)
		if (all_text[i]=="_CO2"){_co2_0 = all_text[i+1]; _co2_100 = all_text[i+2];};
		if (all_text[i]=="_Powering_U"){_powering_0 = all_text[i+1]; _powering_100 = all_text[i+2]};
		if (all_text[i]=="_Fuel_Consumption"){ _FC_0 = all_text[i+1]; _FC_100 = all_text[i+2]};
		if (all_text[i]=="_Availability"){ _availability_0 = all_text[i+1]; _availability_100 = all_text[i+2]};
		if (all_text[i]=="_Crane"){ _crane_0 = all_text[i+1]; _crane_100 = all_text[i+2]};
		if (all_text[i]=="_Accommodation"){ _accommodation_0 = all_text[i+1]; _accommodation_100 = all_text[i+2]};
		if (all_text[i]=="_DP"){ _dp_0 = all_text[i+1]; _dp_100 = all_text[i+2]};
		if (all_text[i]=="_Deck_Area"){ _deck_area_0 = all_text[i+1]; _deck_area_100 = all_text[i+2]};
		if (all_text[i]=="_Ice_Class"){ _ice_class_0 = all_text[i+1]; _ice_class_100 = all_text[i+2]};
		if (all_text[i]=="_Speed"){ _speed_0 = all_text[i+1]; _speed_100 = all_text[i+2]};
		if (all_text[i]=="_ROV"){ _rov_0 = all_text[i+1]; _rov_100 = all_text[i+2]};
		
	};
	
	// ###############################################################################
	
	// Assign variables to a vector
	design_variables = [powering_, ice_class_, speed_, accommodation_, crane_, dp_, rov_number_, deck_area_];
	epoch_variables = [fuel__, offshore_distance__, duration__, depth__, weather__, location__];
	
	// Create design and epoch space
	designs = create_designspace(design_variables);
	epochs = create_epochspace(epoch_variables); 
	
	var text = ("Variables assigned.");

	var html_body = d3.select("body")
		html_body.append("h2")
			.html(text);
};

function go2() {
	
	// Start time of method
	now1 = new Date().getTime() / 1000;
	
	// Assimilate into a single result vector
	results = [];
	r_id = 1;
	for (count_epo = 0; count_epo < epochs.length; count_epo++){
		for (count_des = 0; count_des < designs.length; count_des++){
			r_one_ed = calc_attrib( designs[count_des], epochs[count_epo] );
			result_object = {Analysis: r_id, Design: designs[count_des].id, 
							Epoch: epochs[count_epo].id, 
							// Calculated Attributes
							CAPEX: r_one_ed[0], 
							Fuel_Consumption: r_one_ed[1],  
							Fuel_Utility: calc_util_i(_FC_0, _FC_100, r_one_ed[1]), 
							CO2_Emissions: r_one_ed[3],  
							CO2_Utility: calc_util_i(_co2_0, _co2_100, r_one_ed[3]), 
							OPEX: r_one_ed[2], 
							Revenue: r_one_ed[4],
							// Utilities based on input range
							Power_Utility: calc_util(_powering_0, _powering_100, designs[count_des].Powering),
							Accommodation_Utility: calc_util(_accommodation_0,_accommodation_100, designs[count_des].Accommodation), 
							Crane_Utility: calc_util(_crane_0, _crane_100, designs[count_des].Crane),
							DP_Utility: calc_util(_dp_0, _dp_100, designs[count_des].DP),
							Ice_Class_Utility: calc_util(_ice_class_0, _ice_class_100, designs[count_des].Ice_Class),
							Speed_Utility: calc_util(_speed_0, _speed_100, designs[count_des].Speed),
							ROV_Count_Utility: calc_util(_rov_0, _rov_100, designs[count_des].ROV_Number),
							Deck_Area_Utility: calc_util(_deck_area_0, _deck_area_100, designs[count_des].Deck_Area),
							// DESIGN VARIABLES
							Power: designs[count_des].Powering,
							Accommodation: designs[count_des].Accommodation,
							Crane: designs[count_des].Crane,
							DP: designs[count_des].DP,
							Ice_Class: designs[count_des].Ice_Class,
							Speed: designs[count_des].Speed,
							ROV_Number: designs[count_des].ROV_Number,
							Deck_Area: designs[count_des].Deck_Area,
							// EPOCH VARIABLES
							Depth: epochs[count_epo].Depth,
							Offshore_Distance: epochs[count_epo].Offshore_Distance,
							Duration: epochs[count_epo].Duration,
							Oil_Price: epochs[count_epo].Fuel_Price,
							Weather: epochs[count_epo].Lokasjon,
							Lokasjon: epochs[count_epo].Lokasjon
							};
			results.push(result_object);
			r_id++;
		};
	};
	
	// Prints tradespace size
	var results_str = "Epochs: " + epochs.length + "<br>";
	results_str +=  ("Designs: " + designs.length + "<br>");
	results_str +=  ("Tradespace size: " + results.length + " analyses made. <br> <br> <br>");
	
// ###############################################################################
	
	// What to show on the web page. Controlled by D3
	
	var now2 = new Date().getTime() / 1000;
	var time = ("Total calculation time: " + (now2 - now1).toFixed(3) + " seconds.");

	var html_body = d3.select("body")
		html_body.append("p")
			.html(time);
		html_body.append("div")
			.html(results_str);

};
// end of go()

function printValues() {
	// Define CSV variable
	var results_csv = ["Analysis", "Design", "Epoch", "CAPEX", "Revenue", "Fuel Consumption", "Fuel Utility", "CO2 Emissions", "CO2 Utility", "Power", "Power Utility",  "Accommodation", "Accommodation Utility", "Crane", "Crane Utility", "DP", "DP Utility", "Ice Class", "Ice Class Utility", "Speed", "Speed Utility", "ROV Count", "ROV Utility", "Deck Area", "Deck Area Utility", "Depth", "Offshore Distance", "Duration", "Oil Price", "Weather", "Location", "OPEX" + "<br>"];
				
	// Loop to log all iterations
	for (j = 0; j < results.length; j++) {
	results_csv += (results[j].Analysis + "," + 
					results[j].Design +  "," + 
					results[j].Epoch + "," + 
					results[j].CAPEX + "," + 
					results[j].Revenue + "," + 
					results[j].Fuel_Consumption + "," + 
					results[j].Fuel_Utility + "," + 
					results[j].CO2_Emissions + "," + 
					results[j].CO2_Utility + "," + 
					results[j].Power + "," + 
					results[j].Power_Utility + "," + 
					results[j].Accommodation + "," + 
					results[j].Accommodation_Utility + "," + 
					results[j].Crane + "," + 
					results[j].Crane_Utility + "," +
					results[j].DP + "," + 
					results[j].DP_Utility + "," + 
					results[j].Ice_Class + "," + 
					results[j].Ice_Class_Utility + "," + 
					results[j].Speed + "," + 
					results[j].Speed_Utility + "," + 
					results[j].ROV_Number + "," + 
					results[j].ROV_Count_Utility + "," + 
					results[j].Deck_Area + "," + 
					results[j].Deck_Area_Utility + "," + 
					results[j].Depth + "," + 
					results[j].Offshore_Distance + "," + 
					results[j].Duration + "," + 
					results[j].Oil_Price + "," + 
					results[j].Weather + "," + 
					results[j].Lokasjon + "," + 
					results[j].OPEX + "<br>");
	};
	var html_body = d3.select("body")
		html_body.append("div")
			.html(results_csv);
};